require "modules.camera"
require "modules.metavec3d"
require "modules.matrix3x3"
require "modules.objects"


local k = type

function type(thing)
local t = k(thing)
if t == "table" then
	if k(thing.type) == "string" then
		return thing.type
	end
end
return t
end


centralscreenpos = vec(400,300,0)

--type = mytype
objects = {}

muhangles = vec(0,0,0)


function love.load()
   love.graphics.setColor(255,255,255,255)
   love.graphics.setBackgroundColor(0,162,232)
local pos0 = vec(0,0,0)
local dir = vec(0,0,1)
mycamera = camera.new(pos0,dir,vec(-1,0,0))
--love.mouse.setGrab(true)

table.insert(objects, cube.new(vec(0,0,10),2))
end



function love.update(dt)
	local mx,my = love.mouse.getPosition()
	mx=(mx-400)/10
	my=(my-300)/10

	if mx~=0 or my~=0 then	
		muhangles = muhangles + vec(-my,-mx,0)  -- sen(theta) practically = theta
		muhangles.x = muhangles.x%(2*math.pi)
		muhangles.y = muhangles.y%(2*math.pi)
		muhangles.z = muhangles.z%(2*math.pi)
		mycamera:setrotation(muhangles)
	end

	print("muhangles:", muhangles)
	print("mx,my:", mx,my)

	love.mouse.setPosition(centralscreenpos.x,centralscreenpos.y)


	if love.keyboard.isDown("w") then
		mycamera.position = mycamera.position + dt*mycamera.forward
	end
	if love.keyboard.isDown("a") then
		mycamera.position = mycamera.position - dt*mycamera.right
	end
	if love.keyboard.isDown("s") then
		mycamera.position = mycamera.position - dt*mycamera.forward
	end
	if love.keyboard.isDown("d") then
		mycamera.position = mycamera.position + dt*mycamera.right
	end

end

function love.keypressed(key)
	if key == "tab" then
		local state = not love.mouse.isGrabbed()   -- the opposite of whatever it currently is
      		love.mouse.setGrab(state)
	elseif key == "escape" then
		love.quit()
   	end
end


function love.draw()

for k,v in pairs(objects) do
	--if isincone(v.position) then
	if (v.position - mycamera.position)*mycamera.forward > 0 then
		vertix = {}
		print(#v.vertices)
		for x=1,#v.vertices do
			local d = mycamera:from3dto2d(v.vertices[x])
			print(d)
			table.insert(vertix, d)
		end
		print(#vertix)

		local z = leunpack(vertix)
		print(#z)
		love.graphics.polygon("fill", leunpack(vertix))
	end
end

end



function leunpack(vertices)
local myvert = {}
for x=1,#vertices do
table.insert(myvert, vertices[x].x)
table.insert(myvert, vertices[x].y)
end
return myvert
end


