  Mat = {}

function Mat.sum (a,b)
      if getmetatable(a) ~= Mat.mt or getmetatable(b) ~= Mat.mt then
        error("attempt to `add' a Mat with a non-Mat value", 2)
      end
      local res = Matrix3x3(a.m00+b.m00,a.m01+b.m01,a.m02+b.m02,a.m10+b.m10,a.m11+b.m11,a.m12+b.m12,a.m20+b.m20,a.m21+b.m21,a.m22+b.m22)
      return res
end


function Mat.equal (a,b)
      if getmetatable(a) ~= Mat.mt or getmetatable(b) ~= Mat.mt then
        error("attempt to `compare' a Mat with a non-Mat value", 2)
      end
--[[for x=0,2 do
for y=0,2 do
if not a["m"..x..y] == b["m"..x..y] then return false end
end
end
return true]]
--return (a.x==b.x and a.y==b.y and a.z==b.z)
return (a.m00==b.m00 and a.m01==b.m01 and a.m02==b.m02 and a.m10==b.m10 and a.m11==b.m11 and a.m12==b.m12 and a.m20==b.m20 and a.m21==b.m21 and a.m22==b.m22)
end

function Mat.sub(a,b)
      if getmetatable(a) ~= Mat.mt or getmetatable(b) ~= Mat.mt then
        error("attempt to `subtract' a Mat with a non-Mat value", 2)
      end
      local res = a+(-b)--Vector3d(a.x-b.x,a.y-b.y,a.z-b.z)
      return res
end

function Mat.unm(a)
	local res = (-1)*a    --mat3(-a.m00,-a.m01,-a.m02,-a.m10,-a.m11,-a.m12,-a.m20,-a.m21,-a.m22)
       return res
end

function Mat.tostring(a)
	return "("..a.m00..","..a.m01..","..a.m02..")"  --dps edito, se precisar
end

function Mat.multiply(a,b)  --at least one must be a vector
	print(type(a),type(b))
	if tonumber(a) then --scalar
		return mat3(a*b.m00,a*b.m01,a*b.m02,a*b.m10,a*b.m11,a*b.m12,a*b.m20,a*b.m21,a*b.m22)
	elseif tonumber(b) then --scalar
		return mat3(b*a.m00,b*a.m01,b*a.m02,b*a.m10,b*a.m11,b*a.m12,b*a.m20,b*a.m21,b*a.m22)
	elseif type(a) == "vector" then			--vector and matrix product
		return vec(a.x*b.m00+a.y*b.m01+a.z*b.m02, a.x*b.m10+a.y*b.m11+a.z*b.m12, a.x*b.m20+a.y*b.m21+a.z*b.m22)	--returns a vector
	elseif type(b) == "vector" then
		error("attempt to `multiply' a Mat with a vec in wrong order", 2)
	else  --two matrixes
		-- I dont need it right now, so why bother?
	end
end

Mat.mt = {}    -- metatable for Mats

--[[function Mat.new (t)   -- 2nd version
      local Mat = {}
      setmetatable(Mat, Mat.mt)
      --for _, l in ipairs(t) do Mat[l] = true end
      return Mat
end]]

--[[function Mat:magnitude()
	return math.sqrt(self.x^2 + self.y^2 + self.z^2)
end]]

--[[function Mat:sqrmagnitude()
	return self.x^2 + self.y^2 + self.z^2
end]]

--[[function Mat:normalize()
	return (1/self:magnitude())*self
end]]

--[[function Mat.cross(a,b)
	return vec(a.y*b.z-a.z*b.y,a.z*b.x-a.x*b.z,a.x*b.y-a.y*b.x)
end]]

 Mat.mt.__add = Mat.sum
 Mat.mt.__eq = Mat.equal
 Mat.mt.__index = Mat
 Mat.mt.__sub = Mat.sub
 Mat.mt.__unm = Mat.unm
 Mat.mt.__mul = Mat.multiply
 Mat.mt.__tostring = Mat.tostring
-- Mat.mt.__pow = Mat.cross  --in the lack of a better symbol --n tem isso n


function Matrix3x3(m00,m01,m02,m10,m11,m12,m20,m21,m22)
	local mat = {m00=m00,m01=m01,m02=m02,m10=m10,m11=m11,m12=m12,m20=m20,m21=m21,m22=m22,type="matrix"}
	setmetatable(mat, Mat.mt)
	return mat
end

mat3 = Matrix3x3